from collections import deque, defaultdict

def find(n, m, roads, k, guards):

    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = [False] * (n + 1)

    for p, h in guards:

        queue = deque([(p, 0)])
        visited = set()
        visited.add(p)

        while queue:
            current, distance = queue.popleft()
            if distance <= h:
                guarded[current] = True

                for neighbor in graph[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))

    g = [i for i in range(1, n + 1) if guarded[i]]
    return g

n, m, k = map(int, input().split())

roads = []
for _ in range(m):
    a, b = map(int, input().split())
    roads.append((a, b))

guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))

g = find(n, m, roads, k, guards)

print(len(g))
if g:
    print(" ".join(map(str, sorted(g))))
else:
    print()

